#define __HANDLETIME_C__
#include "../systeminc/version.h"
#include "../systeminc/system.h"
#include <time.h>
#include "../systeminc/handletime.h"

//#ifdef _STONDEBUG_
//(180)????1T
//#define LSTIME_SECONDS_PER_DAY 180
//#else
//(750X12)????S??1T
#define LSTIME_SECONDS_PER_DAY 5400 /* LSTIME?T?????? */
//#endif
/*
  LSTIME_SECONDS_PER_DAY ?????????????????????

  k            LS????T?????????
  9000 (?)   2.5 [hour]
  900           0.25[hour] = 15[min]
  90            0.025[hour] = 1.5[min] = 90[sec]
  9             9[sec]

*/

#define LSTIME_HOURS_PER_DAY 1024 /* LSTIME?T???LSTIME???? */
#define LSTIME_DAYS_PER_YEAR 100 /* LSTIME?g???LSTIME?T? */


// ?????????
LSTIME SaTime;
long serverTime;
long FirstTime;
int SaTimeZoneNo;	// ?????q
BOOL TimeZonePalChangeFlag; // ??q??????????????
#if 0
/*------------------------------------------------------------
 * ??????????????????
 * ??
 *  ??
 * ?k
 *  ?    TRUE(1)
 *      FALSE(0)
 ------------------------------------------------------------*/
BOOL setNewTime( void )
{
    if( gettimeofday( &NowTime, (struct timezone*)NULL) != 0 )
        return FALSE;
    NowTime.tv_sec += DEBUG_ADJUSTTIME;
    return TRUE;
}
#endif

/*******************************************************************
??T????byHiO 1998/12/4 18:37
*******************************************************************/
static long era = (long)912766409 + 5400;
									/* SA??????? */
									/* LS?g?e?????????k?
                                    ???????i?????????*/

/*******************************************************************
	???????LS?????
	long t : time??
	LSTIME *lstime : LSTIME?Bl??????
*******************************************************************/
void RealTimeToSATime( LSTIME *lstime )
{
	long lsseconds; /* LS?g???? */
    long lsdays; /* LS?g???T? */

	//cary ʮ
	lsseconds = (TimeGetTime()-FirstTime)/1000 + serverTime - era;

    /* ?g?????1g?????????g??? */
	lstime->year = (int)( lsseconds/(LSTIME_SECONDS_PER_DAY*LSTIME_DAYS_PER_YEAR) );

    lsdays = lsseconds/LSTIME_SECONDS_PER_DAY;/* ???g???T????? */
	lstime->day  = lsdays % LSTIME_DAYS_PER_YEAR;/* g????T?????????T*/


    /*(750*12)?1T*/
    lstime->hour = (int)(lsseconds % LSTIME_SECONDS_PER_DAY )
/* ???????T???????????? */
        * LSTIME_HOURS_PER_DAY / LSTIME_SECONDS_PER_DAY;
    /* ?T????????????T????????????????
     ????????*/

	return;
}

/*******************************************************************
	LS????????????
	LSTIME *lstime : LSTIME?Bl??????
	long *t : ????????
*******************************************************************/
void LSTimeToRealTime( LSTIME *lstime, long *t)
{
	*t=(long)(
        ( lstime->hour*LSTIME_DAYS_PER_YEAR+lstime->day) /* ?? */
               *LSTIME_HOURS_PER_DAY

        +     lstime->year)
        /*??????????????????nakamura      */


        *450;
	return;
}

/*******************************************************************
	LS?????????x?
	??k int : ?0?1??2??3
	LSTIME *lstime : LSTIME?Bl??????
*******************************************************************/
LSTIME_SECTION getLSTime (LSTIME *lstime)
{
	if (NIGHT_TO_MORNING < lstime->hour
        && lstime->hour <= MORNING_TO_NOON)
		return LS_MORNING;
	else if(NOON_TO_EVENING < lstime->hour
            && lstime->hour <= EVENING_TO_NIGHT)
		return LS_EVENING;
	else if(EVENING_TO_NIGHT < lstime->hour
            && lstime->hour <= NIGHT_TO_MORNING)
		return LS_NIGHT;
	else
		return LS_NOON;
}

// ??q????????????? ***********************************/
void TimeZoneProc( void )
{
	int	timeZoneNo;
	//???????????x?
	timeZoneNo = getLSTime ( &SaTime );
	// ??q?????
	if( SaTimeZoneNo != timeZoneNo ){
		SaTimeZoneNo = timeZoneNo;	// ??q?
		// ??q????????????
		if( TimeZonePalChangeFlag == TRUE ){
			PaletteChange( SaTimeZoneNo, PAL_CHANGE_TIME );// ????????
		}
	}
}
	
