/*-----------------------------------------------------------------------------
    caryMemory_lib.h -- cary's Virtual memory ޲zC
    Waei(c) All rights reserved
    author: \ʳCary Hsu, 2000.10.8
-----------------------------------------------------------------------------*/
#ifndef __MEMDLL
#define __MEMDLL

#define _MEM_LIB

#ifdef _MEM_LIB
	#define MEMDLL_API
#else
	#ifdef MEMDLL_EXPORTS
		#define MEMDLL_API __declspec(dllexport)
	#else
		#define MEMDLL_API __declspec(dllimport)
	#endif
#endif

//^Ǫ~***************************************************************************************
#define ERROR_MEMORY_OK				0x00000000
#define ERROR_MEMORY_INITFAILED		0x00000001	//tmHandle}C~

#define ERROR_HEAP_NOT_ENOUGH		0x00000010
#define ERROR_HEAP_LIST_NOT_ENOUGH	0x00000020

//*************************************************************************************************
/*	lưO禡w
return:	ERROR_MEMORY_OK:		\
		ERROR_MEMORY_INITFAILED:lƥ	*/
DWORD MemoryInit();

/*	O禡wO	*/
void MemoryRelease();

//*************************************************************************************************
/*	Od@jdVirtual MemoryAöǦ^HandleAĳHpage(tm1commit pageO)
parameter:	lpdwHandle:	Ǧ^Handle
			iSize:		ntmhְOAæ^ǫإߪjp
return:		DNULL:		^ǰtmO骺}
			NULL:							*/
MEMDLL_API LPVOID VirtualReserve( LPDWORD lpdwHandle, int &iSize);

/*	HandletmO
parameter:	lpdwHandle:	Handle	*/
MEMDLL_API void VirtualRelease( LPDWORD lpdwHandle);

/*	oExceptionBz禡
parameter:	dwHandle:						Handle
			lpEP:							EXCEPTION_POINTERSstructure
return:		EXCEPTION_CONTINUE_EXECUTION:	~
			EXCEPTION_CONTINUE_SEARCH:		~MiBzexception handle	*/
MEMDLL_API int ExpFilter( DWORD dwHandle, LPEXCEPTION_POINTERS lpEP);

//*************************************************************************************************
//*************************************************************************************************
/*	tmiSizeӰOHeap
parameter:	lpdwHandle:		Ǧ^Handle
			iSize:			ntmh֪O
return:		TRUE:			tm\
			FALSE:							*/
MEMDLL_API BOOL HeapCreate( LPDWORD lpdwHandle, int &iSize);

/*	HeapҦO
parameter:	lpdwHandle:	Handle	*/
MEMDLL_API void HeapRelease( LPDWORD lpdwHandle);

/*	MHeapListAAϥ
parameter:	dwHandle:	Handle	*/
MEMDLL_API void HeapReset( DWORD dwHandle);

/*	qlpheapAtmdwSizejpO
parameter:	dwHandle:	Handle
			dwSize:		ntmhְO
return:		DNULL:		Ǧ^tmO
			NULL:						*/
MEMDLL_API LPVOID HeapAlloc( DWORD dwHandle, DWORD dwSize);

/*	qlpheapHeapmemlt
parameter:	dwHandle:	Handle
			lpAddress:	n񪺰O}}				*/
MEMDLL_API void HeapFree( DWORD dwHandle, LPVOID *lpAddress);

//*************************************************************************************************
//*************************************************************************************************
typedef struct USEDMEMORY{
	LPBYTE			lpbyStart;
	DWORD			dwSize;
}*LPUSEDMEMORY;

/*	^lpheapĤ@Heap list
parameter:	dwHandle:	Handle
return:		Ǧ^ϥΤaddressANULL̫@	*/
MEMDLL_API LPUSEDMEMORY GetMemoryListHead( DWORD dwHandle);

/*	^lpheapU@Heap list
parameter:	dwHandle:	Handle
return:		Ǧ^ϥΤaddressANULL̫@	*/
MEMDLL_API LPUSEDMEMORY GetMemoryListNext( DWORD dwHandle);

/*	^~
parameter:	dwHandle:	Handle
return:		^ǿ~			*/
MEMDLL_API DWORD GetCaryError( DWORD dwHandle);

//*************************************************************************************************
//*************************************************************************************************
/*	hOAϥMMXwpentum IĮΤƪBz
parameter:	dest:	ت}
			src:	ӷ}
			cnt:	hbyte
return:		TRUE:	\
			FALSE:	}Xk						*/
MEMDLL_API BOOL mmx_CopyMemory( LPVOID dest, LPVOID src, int cnt);

/*	hOAϥMMXwpentum IĮΤƪBz
parameter:	dest:	ت}
			src:	ӷ}
			cnt:	hbyte
return:		TRUE:	\
			FALSE:	}Xk						*/
MEMDLL_API BOOL mmx_CopyMemory_test( LPVOID dest, LPVOID src, int cnt);

#endif
